function addPage(page, book) {
	var id, pages = book.turn('pages');
	var element = $('<div />', {});
	if (book.turn('addPage', element, page)) {
		element.html('<div class="gradient"></div><div class="loader"></div>');
		loadPage(page, element);
	}
}

function loadPage(page, pageElement) {
	var img = $('<img />');
	img.mousedown(function(e) {
		e.preventDefault();
	});
	img.load(function() {
		$(this).css({width: '100%', height: '100%'});
		$(this).appendTo(pageElement);
		pageElement.find('.loader').remove();
	});
	img.attr('src', images[page-1]);
}

function loadLargePage(page, pageElement) {
	var img = $('<img />');
	img.load(function() {
		var prevImg = pageElement.find('img');
		$(this).css({width: '100%', height: '100%'});
		$(this).appendTo(pageElement);
		prevImg.remove();
	});
	img.attr('src', large_images[page-1]);
}

function loadSmallPage(page, pageElement) {
	var img = pageElement.find('img');
	img.css({width: '100%', height: '100%'});
	img.unbind('load');
	img.attr('src', images[page-1]);
}

function isChrome() {
	return navigator.userAgent.indexOf('Chrome')!=-1;
}

function disableControls(page) {
		if (page==1)
			$('.previous-button').hide();
		else
			$('.previous-button').show();
		if (page==$('.flipbook').turn('pages'))
			$('.next-button').hide();
		else
			$('.next-button').show();
}

function resizeViewport() {
	var width = $(window).width(),
		height = $(window).height(),
		options = $('.flipbook').turn('options');
	$('.flipbook').removeClass('animated');
	$('.flipbook-viewport').css({
		width: width,
		height: height
	}).
	zoom('resize');
	if ($('.flipbook').turn('zoom')==1) {
		var bound = calculateBound({
			width: options.width,
			height: options.height,
			boundWidth: Math.min(options.width, width),
			boundHeight: Math.min(options.height, height)
		});
		if (bound.width%2!==0)
			bound.width-=1;
		if (bound.width!=$('.flipbook').width() || bound.height!=$('.flipbook').height()) {
			$('.flipbook').turn('size', bound.width, bound.height);
			if ($('.flipbook').turn('page')==1)
				$('.flipbook').turn('peel', 'br');
				$('.flipbook').turn('peel', 'tr');
			$('.next-button').css({height: bound.height, backgroundPosition: '-38px '+(bound.height/2-32/2)+'px'});
			$('.previous-button').css({height: bound.height, backgroundPosition: '-4px '+(bound.height/2-32/2)+'px'});
		}
		$('.flipbook').css({top: -bound.height/2, left: -bound.width/2});
	}


	$('.flipbook').addClass('animated');
}

function largeFlipbookWidth() {
	return 2214;
}

function decodeParams(data) {
	var parts = data.split('&'), d, obj = {};
	for (var i =0; i<parts.length; i++) {
		d = parts[i].split('=');
		obj[decodeURIComponent(d[0])] = decodeURIComponent(d[1]);
	}
	return obj;
}

function calculateBound(d) {
	var bound = {width: d.width, height: d.height};
	if (bound.width>d.boundWidth || bound.height>d.boundHeight) {
		var rel = bound.width/bound.height;
		if (d.boundWidth/rel>d.boundHeight && d.boundHeight*rel<=d.boundWidth) {
			bound.width = Math.round(d.boundHeight*rel);
			bound.height = d.boundHeight;
		} else {
			bound.width = d.boundWidth;
			bound.height = Math.round(d.boundWidth/rel);
		}
	}
	return bound;
}